#include "utils.PRO2"
#include "Arbre.hpp"
#include "ArbIOint.hpp"

int altura(Arbre<int>& a)
/* Pre: a=A */
{
  if (a.es_buit()) return 0;
  else{
    int n=a.arrel();
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);
    int y=altura(a1);
    int z=altura(a2);
    a.plantar(n,a1,a2);
    return max(y,z)+1;
  }
}
/* Post: El resultat és la longitud del camí més llarg de l'arrel a una fulla 
   de l'arbre A; a = A */



int mida(Arbre<int>& a)
/* Pre: a=A */
{
  if (a.es_buit()) return 0;
  else{
    int n=a.arrel();
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);
    int y=mida(a1);
    int z=mida(a2);   
    a.plantar(n,a1,a2);
    return y+z+1;
  }
}
/* Post: El resultat és el nombre de nodes de l'arbre A */



bool cerca(Arbre<int>& a, int x)
/* Pre: a=A */
{
  bool b;
  if (a.es_buit()) return false;
  else if (a.arrel()==x) return true;
  else{
    int n=a.arrel();
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);
    b=cerca(a1,x);
    if (not b) b=cerca(a2,x);
    a.plantar(n,a1,a2);
    return b;
  }
}
/* Post: El resultat indica si x és a l'arbre A o no */

int main(){

  Arbre <int> a;
  llegir_arbre_int(a,0);
  escriure_arbre_int2(a);
  cout << endl;
  cout << "Altura: " << altura(a) << endl;
  cout << "Mida: " << mida(a) << endl;
  cout << "Número a cercar: "; 
  int n;
  cin >> n;
  if (cerca(a,n)) cout << "Hi és" << endl;
  else cout << "No hi és" << endl;
  escriure_arbre_int2(a);
  cout << endl;
}

