#ifndef ARBIOINT_HPP
#define ARBIOINT_HPP

#include "Arbre.hpp"

//Pre: a es buit
void llegir_arbre_int(Arbre<int>& a, int marca){
  int x;
  cin >> x;
  if (x!= marca) {  
    Arbre<int> a1;
    Arbre<int> a2;
    llegir_arbre_int(a1, marca);
    llegir_arbre_int(a2, marca);
    a.plantar(x,a1,a2);
  }
}
//Post: a conté l'abre llegit de l'entrada

//Pre: a = A
void escriure_arbre_int( Arbre<int> &a) {
  if (not a.es_buit()) {
    cout << " " << a.arrel();
    int x = a.arrel();
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);
    escriure_arbre_int(a1); 
    escriure_arbre_int(a2); 
  }
}
//Post: s'ha escrit A pel canal de sortida; a és buit


//La següent versió d'escriure reconstrueix l'arbre, de manera que al
//final queda com estava

//Pre: cert
void escriure_arbre_int2( Arbre<int> &a) {
  if (not a.es_buit()) {
    int x=a.arrel();
    cout << " " << x;
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);
    escriure_arbre_int2(a1); 
    escriure_arbre_int2(a2); 
    a.plantar(x,a1,a2);
  }
//Post: s'ha escrit a pel canal de sortida.
}

#endif

